//+------------------------------------------------------------------+
//|                                                  RiskAdvisor.mq4 |
//|                    |
//|                                              |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property show_inputs

//----  
extern double Risk=2;
extern double StopLoss=0;
extern double OpenPrice=0;
extern double Risk_Reword=3;
extern bool MarketPrice=false;
extern bool Long=true;

//----    
string symbol;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----      23.01.2029.
/*   if (TimeCurrent()>StrToTime("2029.01.23"))
     {
      MessageBox("   .    .","!");
      return(0);
     }*/

//---- ,     USD
   if (AccountCurrency()!="USD")
     {
      MessageBox("     !"+"\n"+
      "   !"," !");
      return(0);
     }

//---- 
   double min_lot;
   double max_lot;
   double step_lot;
   double Balance=AccountBalance();
   double LOT_;
   double LOT;
   double ProfitTarget;
   double tick_step;
   double distance;
   double stoplevel;
   bool cross;
   bool error;

//---- ,         
   if (MarketPrice==true)
     {
      if (Long==true) OpenPrice=Ask;
      else OpenPrice=Bid;
     }

//----       
   symbol=Symbol();
   distance=MarketInfo(symbol,MODE_STOPLEVEL);
   stoplevel=Point*distance;
   if (OpenPrice==0)
     {
      MessageBox("     !"+"\n"+
      "      OpenPrice!","  !");
      error=true;
     }
   if (StopLoss==0)
     {
      MessageBox("     !"+"\n"+
      "      StopLoss!","  !");
      if (error==false) error=true;
     }
   if (MathAbs(OpenPrice-StopLoss)<stoplevel)
     {
      MessageBox("   OpenPrice  StopLoss     "+DoubleToStr(distance,0)+" "+"\n"+
      "        !","  !");
      if (error==false) error=true;
     }
   if (Long==true)
     {
      if (OpenPrice<=StopLoss)
        {
         MessageBox(" .  OpenPrice        StopLoss!"+"\n"+
         "        !","  !");
         if (error==false) error=true;
        }
     }
   else if (Long==false)
     {
      if (OpenPrice>=StopLoss)
        {
         MessageBox(" .  OpenPrice        Stoploss!"+"\n"+
         "        !","  !");
         if (error==false) error=true;
        }
     }
   if (NormalizeDouble(StopLoss/Point,1)!=MathFloor(NormalizeDouble(StopLoss/Point,1)))
     {
      MessageBox("   StopLoss."+"\n"+
      "       "+DoubleToStr(Digits,0)+"\n"+
      "        !","  !");
      if (error==false) error=true;
     }
   if (NormalizeDouble(OpenPrice/Point,1)!=MathFloor(NormalizeDouble(OpenPrice/Point,1)))
     {
      MessageBox("   OpenPrice."+"\n"+
      "       "+DoubleToStr(Digits,0)+"\n"+
      "        !","  !");
      if (error==false) error=true;
     }
   if (MarketInfo(symbol,MODE_PROFITCALCMODE)!=0)
     {
      tick_step=MarketInfo(symbol,MODE_TICKSIZE);
      if(MathMod(NormalizeDouble(StopLoss/Point,Digits),NormalizeDouble(tick_step/Point,Digits))!=0)
        {
         MessageBox("   StopLoss."+"\n"+
         "     "+DoubleToStr(tick_step,Digits)+"\n"+
         "        !","  !");
         if (error==false) error=true;
        }
      if (MathMod(NormalizeDouble(OpenPrice/Point,Digits),NormalizeDouble(tick_step/Point,Digits))!=0)
        {
         MessageBox("   OpenPrice."+"\n"+
         "     "+DoubleToStr(tick_step,Digits)+"\n"+
         "        !","  !");
         if (error==false) error=true;
        }
     }
   if (error==true)
     {
      Comment("StopLoss - ",DoubleToStr(StopLoss,8),"\n","OpenPrice - ",DoubleToStr(OpenPrice,8),"\n",
      "      !");
      MessageBox("      !","  !");
      return(0);
     }

//----          
   for (int pos=0; pos<OrdersTotal(); pos++)
     {
      if (OrderSelect(pos,SELECT_BY_POS)==true)
        {
         if (OrderType()==OP_BUY || OrderType()==OP_SELL)
           {
            symbol=OrderSymbol();
            if (MarketInfo(symbol,MODE_PROFITCALCMODE)==0 && StringFind(symbol,"USD")==-1)
              {
               cross=true;
               break;
              }
           }
        }
     }
   if (cross==true) MessageBox("   -    !","!");
   for (pos=0; pos<OrdersTotal(); pos++)
     {
      if (OrderSelect(pos,SELECT_BY_POS)==true)
        {
         if (OrderStopLoss()==0)
           {
            MessageBox("    !"+"\n"+
            "   !"," !");
            return(0);
           }
         if (OrderType()==OP_BUY || OrderType()==OP_SELL)
           {
            symbol=OrderSymbol();
            Balance=Balance+PositionCloseCalc(MarketInfo(symbol,MODE_PROFITCALCMODE),OrderOpenPrice(),OrderStopLoss(),OrderLots(),OrderType())+OrderSwap()+OrderCommission();
           }
        }
     }

//----     
   symbol=Symbol();
   min_lot=MarketInfo(symbol,MODE_MINLOT);
   max_lot=MarketInfo(symbol,MODE_MAXLOT);
   step_lot=MarketInfo(symbol,MODE_LOTSTEP);
   switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
     {
      case 0:
        pos=StringFind(symbol,"USD");
        LOT_=MathAbs(0.01*Risk*Balance/((StopLoss-OpenPrice)*MarketInfo(symbol,MODE_LOTSIZE)));
        if (pos==0) LOT_=LOT_*StopLoss;
        else if (pos==-1)
          {
           MessageBox("   -    !","!");
           symbol=StringSubstr(symbol,3);
           symbol=StringConcatenate("USD",symbol);
           if (MarketInfo(symbol,MODE_LOTSIZE)!=0) LOT_=LOT_*MarketInfo(symbol,MODE_BID);
           else
             {
              symbol=StringSubstr(symbol,3);
              symbol=StringConcatenate(symbol,"USD");
              if (MarketInfo(symbol,MODE_LOTSIZE)!=0) LOT_=LOT_/MarketInfo(symbol,MODE_ASK);
              else MessageBox("  .    ."+"\n"+
                   "   !"," !");
             }
          }
      break;
      //----
      default:
        double tick_price=MarketInfo(symbol,MODE_TICKVALUE);
        LOT_=MathAbs(0.01*Risk*Balance*tick_step/((StopLoss-OpenPrice)*tick_price));
      break;
     }
   LOT=MathRound(LOT_/step_lot)*step_lot;
   if (LOT<min_lot) LOT=min_lot;
   if (LOT>max_lot)
     {
      MessageBox("   ."+"\n"+
      "     OpenPrice  StopLoss"+"\n"+
      "       ","!");
      return(0);
     }

//----    
   symbol=Symbol();
   double risk=100*PositionCloseCalc(MarketInfo(symbol,MODE_PROFITCALCMODE),OpenPrice,StopLoss,LOT,Long)/Balance;

//----  
    pos=StringFind(symbol,"USD");
    if (MarketInfo(symbol,MODE_PROFITCALCMODE)==0 && pos==0)
      {
       if (Long==true) ProfitTarget=OpenPrice/(1-Risk_Reword*(OpenPrice-StopLoss)/StopLoss);
       else ProfitTarget=OpenPrice/(1+Risk_Reword*(StopLoss-OpenPrice)/StopLoss);
      }
    else
      {
       if (Long==true) ProfitTarget=OpenPrice+Risk_Reword*(OpenPrice-StopLoss);
       else ProfitTarget=OpenPrice-Risk_Reword*(StopLoss-OpenPrice);
      }

//----   
   Comment("  - ",min_lot,"\n","  - ",DoubleToStr(LOT_,3),"\n","  - ",Risk,"%","\n",
   "  - ",LOT,"\n","  - ",DoubleToStr(risk,3),"%","\n","StopLoss - ",DoubleToStr(StopLoss,Digits),"\n",
   "OpenPrice - ",DoubleToStr(OpenPrice,Digits),"\n","ProfitTarget - ",DoubleToStr(ProfitTarget,Digits),"\n","  - ",Balance," $");
   Print("  - ",Balance," $");
   Print("StopLoss - ",DoubleToStr(StopLoss,Digits),"; OpenPrice - ",DoubleToStr(OpenPrice,Digits),"; ProfitTarget - ",DoubleToStr(ProfitTarget,Digits));
   Print("  - ",LOT,";   - ",DoubleToStr(risk,3),"%");
   Print("  - ",DoubleToStr(LOT_,3),";   - ",Risk,"%");
   Print("  - ",min_lot);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//----     (  )    
double PositionCloseCalc(int CalcMode, double openprice, double stoploss, double lots, int order_type)
  {
   double position_close_calc;
   switch (CalcMode)
     {
      case 0:
        if (order_type==OP_BUY) position_close_calc=(stoploss-openprice)*MarketInfo(symbol,MODE_LOTSIZE)*lots;
        else position_close_calc=(openprice-stoploss)*MarketInfo(symbol,MODE_LOTSIZE)*lots;
        int pos=StringFind(symbol,"USD");
        if (pos==0) position_close_calc=position_close_calc/stoploss;
        else if (pos==-1)
          {
           symbol=StringSubstr(symbol,3);
           symbol=StringConcatenate("USD",symbol);
           if (MarketInfo(symbol,MODE_LOTSIZE)!=0) position_close_calc=position_close_calc/MarketInfo(symbol,MODE_ASK);
           else
             {
              symbol=StringSubstr(symbol,3);
              symbol=StringConcatenate(symbol,"USD");
              if (MarketInfo(symbol,MODE_LOTSIZE)!=0) position_close_calc=position_close_calc*MarketInfo(symbol,MODE_BID);
              else MessageBox("  .    ."+"\n"+
                   "   !"," !");
             }
          }
      break;
      //----
      default:
        double tick_step=MarketInfo(symbol,MODE_TICKSIZE);
        double tick_price=MarketInfo(symbol,MODE_TICKVALUE);
        if (order_type==OP_BUY) position_close_calc=(stoploss-openprice)*lots*tick_price/tick_step;
        else position_close_calc=(openprice-stoploss)*lots*tick_price/tick_step;
      break;
     }
   return(position_close_calc);
  }